libzypp 17.37.10

zypp::ContentType Class Reference

Mime type like `'type/subtype'` classification of content. More...

`#include <zypp/ContentType.h>`

## Public Member Functions
| ContentType ()
| Default ctor: empty.
| ContentType (std::string type_r)
| Ctor taking "type[/subtype]"
| ContentType (std::string type_r, std::string subtype_r)
| Ctor taking type and subtype.
const std::string & | type () const
| Get type.
void | type (std::string type_r)
| Set type.
const std::string & | subtype () const
| Get subtype.
void | subtype (std::string subtype_r)
| Set subtype.
bool | empty () const
| Whether type and subtype are empty.
bool | emptyType () const
| Whether type is empty.
bool | emptySubtype () const
| Whether subtype is empty.
| operator bool () const
| Validate object in a boolean context: !empty.
std::string | asString () const
| String representation "type[/subtype]"

## Private Member Functions
void | testAndSet (std::string &var_r, std::string val_r)

## Private Attributes
std::string | _type
std::string | _subtype

## Related Symbols
(Note that these are not member symbols.)
std::ostream & | operator<< (std::ostream &str, const ContentType &obj)
| Stream output.
bool | operator== (const ContentType &lhs, const ContentType &rhs)
bool | operator!= (const ContentType &lhs, const ContentType &rhs)
bool | operator< (const ContentType &lhs, const ContentType &rhs)
bool | operator<= (const ContentType &lhs, const ContentType &rhs)
bool | operator> (const ContentType &lhs, const ContentType &rhs)
bool | operator>= (const ContentType &lhs, const ContentType &rhs)

## Detailed Description

Mime type like `'type/subtype'` classification of content.

Used e.g. in callback::UserData to describe the kind of user data passed as `void*` to a callback. Neither type nor subtype may contain a '/'.

Definition at line 29 of file ContentType.h.

## Constructor & Destructor Documentation

## ◆ ContentType() [1/3]

zypp::ContentType::ContentType | ( |  | ) |
| inline

Default ctor: empty.

Definition at line 33 of file ContentType.h.

## ◆ ContentType() [2/3]

zypp::ContentType::ContentType | ( | std::string | type_r | ) |
| inline explicit

Ctor taking "type[/subtype]"

Exceptions

  std::invalid_argument | if string is malformed

Definition at line 39 of file ContentType.h.

## ◆ ContentType() [3/3]

zypp::ContentType::ContentType | ( | std::string | type_r,
|  | std::string | subtype_r )
| inline

Ctor taking type and subtype.

Exceptions

  std::invalid_argument | if string is malformed

Definition at line 53 of file ContentType.h.

## Member Function Documentation

## ◆ type() [1/2]

const std::string & zypp::ContentType::type | ( |  | ) | const
| inline

Get type.

Definition at line 61 of file ContentType.h.

## ◆ type() [2/2]

void zypp::ContentType::type | ( | std::string | type_r | ) |
| inline

Set type.

Exceptions

  std::invalid_argument | if string is malformed

Definition at line 67 of file ContentType.h.

## ◆ subtype() [1/2]

const std::string & zypp::ContentType::subtype | ( |  | ) | const
| inline

Get subtype.

Definition at line 71 of file ContentType.h.

## ◆ subtype() [2/2]

void zypp::ContentType::subtype | ( | std::string | subtype_r | ) |
| inline

Set subtype.

Exceptions

  std::invalid_argument | if string is malformed

Definition at line 77 of file ContentType.h.

## ◆ empty()

bool zypp::ContentType::empty | ( |  | ) | const
| inline

Whether type and subtype are empty.

Definition at line 82 of file ContentType.h.

## ◆ emptyType()

bool zypp::ContentType::emptyType | ( |  | ) | const
| inline

Whether type is empty.

Definition at line 85 of file ContentType.h.

## ◆ emptySubtype()

bool zypp::ContentType::emptySubtype | ( |  | ) | const
| inline

Whether subtype is empty.

Definition at line 88 of file ContentType.h.

## ◆ operator bool()

zypp::ContentType::operator bool | ( |  | ) | const
| inline explicit

Validate object in a boolean context: !empty.

Definition at line 92 of file ContentType.h.

## ◆ asString()

std::string zypp::ContentType::asString | ( |  | ) | const
| inline

String representation "type[/subtype]"

Definition at line 96 of file ContentType.h.

## ◆ testAndSet()

void zypp::ContentType::testAndSet | ( | std::string & | var_r,
|  | std::string | val_r )
| inline private

Definition at line 100 of file ContentType.h.

## Friends And Related Symbol Documentation

## ◆ operator<<()

std::ostream & operator<< | ( | std::ostream & | str,
|  | const ContentType & | obj )
| related

Stream output.

Definition at line 112 of file ContentType.h.

## ◆ operator==()

bool operator== | ( | const ContentType & | lhs,
|  | const ContentType & | rhs )
| related

Definition at line 116 of file ContentType.h.

## ◆ operator!=()

bool operator!= | ( | const ContentType & | lhs,
|  | const ContentType & | rhs )
| related

Definition at line 120 of file ContentType.h.

## ◆ operator<()

bool operator< | ( | const ContentType & | lhs,
|  | const ContentType & | rhs )
| related

Definition at line 124 of file ContentType.h.

## ◆ operator<=()

bool operator<= | ( | const ContentType & | lhs,
|  | const ContentType & | rhs )
| related

Definition at line 128 of file ContentType.h.

## ◆ operator>()

bool operator> | ( | const ContentType & | lhs,
|  | const ContentType & | rhs )
| related

Definition at line 132 of file ContentType.h.

## ◆ operator>=()

bool operator>= | ( | const ContentType & | lhs,
|  | const ContentType & | rhs )
| related

Definition at line 136 of file ContentType.h.

## Member Data Documentation

## ◆ _type

std::string zypp::ContentType::_type
| private

Definition at line 107 of file ContentType.h.

## ◆ _subtype

std::string zypp::ContentType::_subtype
| private

Definition at line 108 of file ContentType.h.

The documentation for this class was generated from the following file:

- zypp/ContentType.h